#include "stdafx.h"
#include "LibFile.h"
#include <algorithm>
#include <functional>


//=============================================================================
#include <PshPack1.h>


//! 2JõoƃItZbgzB
struct MemberOffsets
{
  DWORD member_length;
  DWORD offsets[1];
};

//! 2JõV{AoCfbNX̔zB
struct OffsetIndexFromSymbolIndex
{
  DWORD symbol_length;
  WORD  offset_index_from_symbol_index[1];
};


#include <PopPack.h>
//=============================================================================


//! end_header  size ɗLȒlĂ邩ׂB
bool ArchiveMemberHeader::IsValid() const
{
  return memcmp(end_header, "`\n", sizeof(end_header)) == 0 && GetSize() != 0;
}


//=============================================================================


//! O擾B
std::string ArchiveMemberHeader::GetName() const
{
  char* p = reinterpret_cast<char*>(_alloca(sizeof(name) + 1));

  // '\0' ŏI[镶ƂăRs[
  memcpy(memset(p, '\0', sizeof(name) + 1), name, sizeof(name));
  // [̋󔒂
  StrTrimA(p, " "); 

  // '/' Ŏn܂Ă炸AŌ̕ '/' ̏ꍇ '/' B
  if( p[0] != '/' && p[strlen(p) - 1] == '/' )
    p[strlen(p) - 1] = '\0';

  return std::string(p);
}


//=============================================================================


//! õTCY擾B
size_t ArchiveMemberHeader::GetSize() const
{
  char* p = reinterpret_cast<char*>(_alloca(sizeof(size) + 1));

  // '\0' ŏI[镶ƂăRs[
  memcpy(memset(p, '\0', sizeof(size) + 1), size, sizeof(size));
  // [̋󔒂
  StrTrimA(p, " "); 

  return atoi(p);
}


//=============================================================================


//! t@C std::vector<BYTE> ɓǂݍށB
static bool LoadFile(const wchar_t* i_obj_path, std::vector<BYTE>& o_data)
{
  bool            retval      = false;
  HANDLE          file_handle = INVALID_HANDLE_VALUE;
  LARGE_INTEGER   file_size   = { 0 };
  DWORD           read_size   = 0;

  do
  {
    file_handle = CreateFileW(
                    i_obj_path,
                    GENERIC_READ,
                    FILE_SHARE_READ,
                    NULL,
                    OPEN_EXISTING,
                    FILE_ATTRIBUTE_NORMAL,
                    NULL
                  );
    if( file_handle == INVALID_HANDLE_VALUE )
    {
      _RPTF2(_CRT_WARN,
             "unable to open file[%s] : 0x%08X.\n",
             i_obj_path, GetLastError()
            );
      break;
    }
    
    if( GetFileSizeEx(file_handle, &file_size) == FALSE )
    {
      _RPTF1(_CRT_WARN, "unable to get file size : 0x%08X.\n", GetLastError());
      break;
    }
    
    if( file_size.HighPart
    ||  file_size.LowPart > LONG_MAX
    ||  file_size.LowPart == 0 )
    {
      _RPTF0(_CRT_WARN, "invalid file size\n");
      break;
    }
    
    o_data.resize(file_size.LowPart, 0);
    if( ReadFile(file_handle, &o_data[0], file_size.LowPart, &read_size, NULL)
        == FALSE )
    {
      _RPTF1(_CRT_WARN, "unable to read file : 0x%08X.\n", GetLastError());
      break;
    }
    
    retval = true;
  }
  while( 0 );

  if( file_handle != INVALID_HANDLE_VALUE )
  {
    CloseHandle(file_handle);
    file_handle = INVALID_HANDLE_VALUE;
  }

  return retval;
}


//=============================================================================


//! RXgN^Blib t@CǂݍށB
LibFile::LibFile(const wchar_t* i_file_path)
: m_is_opened(false),
  m_lib_data(),
  m_member_length(0),
  m_member_offsets_p(NULL),
  m_symbol_length(0),
  m_offset_index_from_symbol_index_p(NULL),
  m_symbol_names()
{
  do
  {
    if( LoadFile(i_file_path, m_lib_data) == false )
    {
      _RPTF1(_CRT_WARN, "%S J܂łB\n", i_file_path);
      break;
    }
    
    if( IsLibFile(&m_lib_data[0], m_lib_data.size()) == false )
    {
      _RPTF1(_CRT_WARN, "%S ̓Cut@Cł͂܂B\n", i_file_path);
      break;
    }
    
    // 2Jõowb_ւ̃|C^擾B
    const ArchiveMemberHeader* header_p = GetMemberHeaderPtr(1);
    if( header_p == NULL || header_p->GetName() != "/" )
    {
      _RPTF0(_CRT_WARN, "2Jo܂ł܂B\n");
      break;
    }
    
    // 2JoANZX₷`ŕێĂB
    m_member_length = GetMemberLength(header_p->member_data);
    m_member_offsets_p = GetMemberOffsets(header_p->member_data);
    m_symbol_length = GetSymbolLength(header_p->member_data);
    m_offset_index_from_symbol_index_p = GetOffsetIndices(header_p->member_data);
    
    // V{e[u std::vector<std::string> ɕϊ
    m_symbol_names.reserve(m_symbol_length);
    const char* p = GetSymbolNames(header_p->member_data);
    for(size_t i = 0; i < m_symbol_length; i++)
    {
      m_symbol_names.push_back(p);
      p += strlen(p) + 1;
    }
    
    m_is_opened = true;
  }
  while( 0 );
}


//=============================================================================


//! JǂmFB
bool LibFile::IsOpened() const
{
  return m_is_opened;
}


//=============================================================================


//! i_index Ԗ(0-based)̃owb_ւ̃|C^擾B
const ArchiveMemberHeader* LibFile::GetMemberHeaderPtr(int i_index) const
{
  const ArchiveMemberHeader*  retval    = NULL;
  const ArchiveMemberHeader*  header_p  = NULL;
  
  if( m_lib_data.size() )
  {
    const BYTE*   p = &m_lib_data[0] + IMAGE_ARCHIVE_START_SIZE;

    for(int i = 0; i <= i_index; i++)
    {
      header_p = reinterpret_cast<const ArchiveMemberHeader*>(p);
      if( IsValidPtr(header_p, sizeof(*header_p)) == false
      ||  header_p->IsValid() == false )
      {
        break;
      }
      
      if( i == i_index )
      {
        retval = header_p;
        break;
      }

      // ̃owb_ցB2oCgEɂȂƂȂB
      p += (sizeof(ArchiveMemberHeader) + header_p->GetSize() + 1) & ~1;
    }
  }
  
  return retval;
}


//=============================================================================


//! V{܂ރA[JCuõwb_ւ̃|C^擾B
const ArchiveMemberHeader* LibFile::FindSymbol(const std::string& i_symbol_name)
{
  const ArchiveMemberHeader*  retval = NULL;

  if( m_is_opened )
  {
    std::vector<std::string>::iterator itr = std::lower_bound(
                                               m_symbol_names.begin(),
                                               m_symbol_names.end(),
                                               i_symbol_name
                                             );
    if( itr != m_symbol_names.end() && *itr == i_symbol_name )
    {
      int symbol_index  = itr - m_symbol_names.begin();
      int offset_index  = m_offset_index_from_symbol_index_p[symbol_index] - 1;
      int member_offset = m_member_offsets_p[offset_index];

      retval = reinterpret_cast<const ArchiveMemberHeader*>(
                 &m_lib_data[0] + member_offset
               );
      if( IsValidPtr(retval, sizeof(*retval)) == false
      ||  retval->IsValid() == false )
      {
        retval = NULL;
      }
    }
  }
  
  return retval;
}


//=============================================================================


//! Lȃ|C^ǂׂ
bool LibFile::IsValidPtr(const void* i_ptr, size_t i_size) const
{
  const void* end_p = reinterpret_cast<const BYTE*>(i_ptr) + i_size;

  return &m_lib_data[0] <= i_ptr && end_p <= &m_lib_data[0] + m_lib_data.size();
}


//=============================================================================


//! lib t@CǂׂB
bool LibFile::IsLibFile(const BYTE* i_ptr, size_t i_size)
{
  return i_size > IMAGE_ARCHIVE_START_SIZE
      && IsBadReadPtr(i_ptr, IMAGE_ARCHIVE_START_SIZE) == FALSE
      && memcmp(i_ptr, IMAGE_ARCHIVE_START, IMAGE_ARCHIVE_START_SIZE) == 0
      ;
}


//=============================================================================


//! 2Jo烊Joo擾B
size_t LibFile::GetMemberLength(const BYTE* i_second_linker_member_p)
{
  return reinterpret_cast<const MemberOffsets*>(i_second_linker_member_p)->member_length;
}


//=============================================================================


//! 2Jo烁oւ̃ItZbgzւ̃|C^擾B
const DWORD* LibFile::GetMemberOffsets(const BYTE* i_second_linker_member_p)
{
  return reinterpret_cast<const MemberOffsets*>(i_second_linker_member_p)->offsets;
}


//=============================================================================


//! 2JoV{擾B
size_t LibFile::GetSymbolLength(const BYTE* i_second_linker_member_p)
{
  size_t        member_length   = GetMemberLength(i_second_linker_member_p);
  const DWORD*  member_offsets  = GetMemberOffsets(i_second_linker_member_p);

  return reinterpret_cast<const OffsetIndexFromSymbolIndex*>(
           &member_offsets[member_length]
         )->symbol_length;
}


//=============================================================================


//! 2JoV{̃CfbNXoItZbg̃C
//  fbNXɕϊzւ̃|C^擾B
const WORD* LibFile::GetOffsetIndices(const BYTE* i_second_linker_member_p)
{
  size_t        member_length   = GetMemberLength(i_second_linker_member_p);
  const DWORD*  member_offsets  = GetMemberOffsets(i_second_linker_member_p);

  return reinterpret_cast<const OffsetIndexFromSymbolIndex*>(
           &member_offsets[member_length]
         )->offset_index_from_symbol_index;
}


//=============================================================================


//! 2JoV{e[uւ̃|C^擾B
const char* LibFile::GetSymbolNames(const BYTE* i_second_linker_member_p)
{
  size_t        symbol_length  = GetSymbolLength(i_second_linker_member_p);
  const WORD*   offset_indices = GetOffsetIndices(i_second_linker_member_p);
  
  return reinterpret_cast<const char*>(&offset_indices[symbol_length]);
}


//=============================================================================


