#ifndef __LIB_FILE_H_INCLUDED__
#define __LIB_FILE_H_INCLUDED__
#include <PshPack1.h>


//! A[JCuowb_(+ f[^̐擪)
struct ArchiveMemberHeader
{
  BYTE    name[16];       //!< OB
  BYTE    date[12];       //!< ^CX^vB
  BYTE    user_id[6];     //!< gpȂB
  BYTE    group_id[6];    //!< gpȂB
  BYTE    mode[8];        //!< gpȂB
  BYTE    size[10];       //!< õTCYB
  BYTE    end_header[2];  //!< wb_̃Gh}[J[B
  BYTE    member_data[1]; //!< õf[^̐擪B

  //! end_header  size ɗLȒlĂ邩ׂB
  bool IsValid() const;
  //! O擾B
  std::string GetName() const;
  //! õTCY擾B
  size_t GetSize() const;
};


//! lib t@CNXB
class LibFile
{
  //===========================================================================
  // J\bh
  //===========================================================================
public:
  //! RXgN^B lib t@CJB
  explicit LibFile(const wchar_t* i_file_path);

  //! JǂmFB
  bool IsOpened() const;

  //! i_index Ԗ(0-based)̃owb_ւ̃|C^擾B
  const ArchiveMemberHeader* GetMemberHeaderPtr(int i_index) const;
  //! V{܂ރA[JCuõwb_ւ̃|C^擾B
  const ArchiveMemberHeader* FindSymbol(const std::string& i_symbol_name);

private:
  //! Lȃ|C^ǂׂB
  bool IsValidPtr(const void* i_ptr, size_t i_size) const;

  //! lib t@CǂׂB
  static bool IsLibFile(const BYTE* i_ptr, size_t i_size);
  
  //! 2Jo烊Joo擾B
  static size_t GetMemberLength(const BYTE* i_second_linker_member_p);
  //! 2Jo烁oւ̃ItZbgzւ̃|C^擾B
  static const DWORD* GetMemberOffsets(const BYTE* i_second_linker_member_p);
  //! 2JoV{擾B
  static size_t GetSymbolLength(const BYTE* i_second_linker_member_p);
  //! 2JoV{̃CfbNXoItZbg̃C
  //  fbNXɕϊzւ̃|C^擾B
  static const WORD* GetOffsetIndices(const BYTE* i_second_linker_member_p);
  //! 2JoV{e[uւ̃|C^擾B
  static const char* GetSymbolNames(const BYTE* i_second_linker_member_p);

private:
  bool                        m_is_opened;
  std::vector<BYTE>           m_lib_data;
  size_t                      m_member_length;
  const DWORD*                m_member_offsets_p;
  size_t                      m_symbol_length;
  const WORD*                 m_offset_index_from_symbol_index_p;
  std::vector<std::string>    m_symbol_names;
};


#include <PopPack.h>
#endif
